{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit demo_stream;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type
  Ts20 = string[20];

  TdemoRec = record
    aChar: Char;
    anInt: integer;
    aString: Ts20;
    aDate: TDateTime;
  end;

  { TdemoStream }

  TdemoStream = class(TMemoryStream)
   private
    function GenerateRandomRec(num: integer): TdemoRec;
   public
    rec: TdemoRec;
    constructor Create(numRecords: integer);
    function RecAsString: string;
  end;

implementation

uses math;

{ TdemoStream }

function TdemoStream.GenerateRandomRec(num: integer): TdemoRec;
begin
  Result.aChar:= chr(65 + Random(26));
  Result.aDate:= TDateTime(RandomRange(100, trunc(Now)) + Random/10000);
  Result.anInt:= num;
  Result.aString:= Format('example string %d',[num]);
end;

constructor TdemoStream.Create(numRecords: integer);
var i: integer;
begin
  Randomize;
  inherited Create;
  Position:= 0;
  for i := 0 to numRecords-1 do
   Write(GenerateRandomRec(i), SizeOf(TdemoRec));
end;

function TdemoStream.RecAsString: string;
begin
  Read(rec, SizeOf(rec));
  Result := Format('%5d %s %17s %s',
                   [rec.anInt, rec.aChar, rec.aString,
                   FormatDateTime('dd-mm-yyyy:mm:ss',rec.aDate)]);
end;

end.

